<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetControllerGroup extends JControllerForm {
	
	protected	$option 		= 'com_jextranet';
	protected 	$text_prefix	= 'COM_JEXTRANET_GROUPS';
	
    public function getJsonItems()
    {
        $input = JFactory::getApplication()->input;
        $parentFolder = $input->get('parent',0,'int');
        $offset = $input->get('offset',0,'int');
        $group = $input->get('group',0,'int');

        echo json_encode($this->getModel()->permissionsJsonData(
            $parentFolder, $offset, $group
        ));
        exit();
    }

    public function permission()
    {
        $input = JFactory::getApplication()->input;
        $gid = $input->get('group', 0, 'int');
        $folder = $input->get('folder', '0', 'string');
        $permission = $input->get('permission', 0, 'int');
        $task = $input->get('do', 'set', 'string');
        $model = $this->getModel();

        $permissions = $model->getStoredPermissions($gid);

        if (!isset($permissions->{$folder})) {
            $permissions->{$folder} = array();
        }

        if ($task == 'set') {
            $updated = $this->pushItem(
                            $permissions->{$folder}, $permission);
        } else {
            $updated = $this->removeItem(
                            $permissions->{$folder}, $permission);
        }

        $permissions->{$folder} = $updated;
        $params = new stdclass;
        $params->permissions = $permissions;
        $table = $model->getTable();
        $table->load($gid);
        $table->g_params = json_encode($params);
        $table->store();

        if ($folder == 'all') {
            $response = $model->permissionsJsonData(0,0,$gid,1);
        } else {
            $response = $model->getPermissions($folder, $permissions);
        }

        echo json_encode($response);exit();
    }

    protected function pushItem($list, $item) {
        if(empty($list)) {
            $list[] = (string) $item;
        } else {
            if(!in_array($item, $list)) {
                $list[] = (string) $item;
            }
        }
        return $list;
    }

    protected function removeItem($list, $item) {
        if (!empty($list)) {
            if (in_array($item, $list)) {
                $key = array_keys($list, $item);
                unset($list[$key[0]]);
                sort($list);
            }
        }
        return $list;
    }
}
