<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');



class JExtranetControllerUserfiles extends JControllerAdmin {
	
	protected	$option 		= 'com_jextranet';
	protected 	$text_prefix	= 'COM_JEXTRANET_FILES';
	
    public function getModel($name = 'File', $prefix = 'JExtranetModel',
                                $config = array('ignore_request' => true))
    {
		$model = parent::getModel($name, $prefix, $config);
		return $model;
	}
	
    public function cancel()
    {
		$this->setRedirect('index.php?option=com_jextranet&view=users');
	}

    public function deleteAjax()
    {
		JRequest::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));
		
		$id 				= JRequest::getVar('cid', 0, '', 'int');
		$user 				= JRequest::getVar('user', 0, '', 'int');
		$ids				= array( $id );
		$response			= new stdclass;
		$response->error 	= 0;
		$model 	= $this->getModel();
		
		if (!$id || !$user) {
			$response->error = 1;
		}
        if (!$model->deleteUFiles($ids, $user)){
            $response->error = 1;
        }
		flush();
		echo json_encode( $response );
		exit();
	}

	public function download() {
		
		$model 	= $this->getModel('Userfiles', 'JExtranetModel');
		$id  = JRequest::getVar('cid',0,'','int');

		if ( $id ) {
			$file = $model->getFile( $id );
			if ( $file->f_id ) {
				$model->getHeaders();
				$model->getContent();
			}
		} 
		$this->setRedirect ( base64_decode( JRequest::getVar('return') ) );
	}
	
	
	public function uploadAjax() {
		
		// Check for request forgeries
		JSession::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));
		
		$model 			= $this->getModel('Userfiles','JExtranetModel');
		$folder			= $model->getPath();

		$post			= new stdclass();
		$post->error 	= null;
		$post->filename = null;
		$post->path 	= null;
		$post->size 	= null;
		$post->dt 		= null;
		
		$file 				= array();
		$file['name'] 		= $_FILES['mf_file_upload']['name'];
		$file['tmp_name'] 	= $_FILES['mf_file_upload']['tmp_name'];
		$file['f_size']		= $_FILES['mf_file_upload']['size'];
		
		if (!JFolder::exists($folder)){
			JFolder::create($folder);
		}
	
		if ( JFile::exists( $folder . $file['name'] ) ) {
			$post->error = JText::_('COM_JEXTRANET_ERROR_FILE_EXISTS');
			flush();
			echo json_encode( $post );
			exit();
		}
			
		if (!JFile::upload($file['tmp_name'], $folder . $file['name'] )) {
			$post->error = JText::_('COM_JEXTRANET_ERROR_UNABLE_TO_UPLOAD_FILE');
			flush();
			echo json_encode( $post );
			exit();
		}
		
		$fileinfo 	= $this->getFileInfo( $file['name'] );

		$filename 	= mb_convert_encoding($fileinfo->basename, 'UTF-8');
			
		$f = new stdClass();
		$f->f_title 		= $filename;
		$f->f_alias 		= $file['name'];
		$f->f_type			= $fileinfo->extension;
		$f->f_size			= $file['f_size'];
		$f->f_created 		= JExtranetHelper::getSystem()->getDateToMySQL();
		$f->f_created_by 	= JRequest::getVar('id', null);
		$model->addFileDb( $f );
		
        $post->filename		= $file['name'];
        $post->size			= JExtranetHelper::getSystem()
                                    ->parseSize($file['f_size']);
        $post->Files		= JExtranetHelper::getUser($f->f_created_by)
                                    ->getVaultFiles();
		$rezult = json_encode($post);

		$this->email($f);
        $this->message($f);
        echo $rezult;
		flush();
		exit();
	}
	

	protected function getFileInfo( $filename ) {

		$file = new stdClass;
		$file->basename 	= null;
		$file->extension 	= null;
		$file->length 		= strlen( $filename );

		if ( substr_count( $filename, '.') == 0 ) {
			$file->basename 	= $filename;
		}

		if ( substr_count( $filename, '.') == 1 ) {
			
			$regex 		= '/^\.[^.]*$/';

			// if file starts with a dot
			if ( preg_match( $regex, $filename ) ) {
				$file->basename = str_replace('.', '', $filename);
			} else {
				$parts = explode('.', $filename);
				$file->basename = $parts[0];
				$file->extension = $parts[1];
			}
		}


		if ( substr_count( $filename, '.') >= 2 ) {
			$pattern = '/.[^.]*$/';

			if ( preg_match( $pattern, $filename, $found ) ) {
				$file->extension = str_replace('.', '', $found[0]);
				$file->basename = substr( $filename, 0, ($file->length - strlen( $file->extension) - 1 ) );
			}

		} 

		return $file;
	}

    protected function email($file) {
        $params = JComponentHelper::getParams('com_jextranet');
        $receiver = null;
        $receivers = array();

        if ($params->get('vaultAlerts', 0) == 0) {
            return;
        }

        $email 	= JFactory::getApplication('administrator')->getCfg('mailfrom');
        $sender = JFactory::getApplication('administrator')->getCfg('fromname');
        $receiver = JFactory::getUser($file->f_created_by)->email;
        $subject = $this->tags_replace(
            $params->get('notify_user_new_vault_file_subject', ''), $file
        );
        $body = $this->tags_replace(
            $params->get('notify_user_new_vault_file_body', ''), $file
        );

        JFactory::getMailer()->sendMail(
            $email, $sender, $receiver, $subject, $body, true
        );
    }

    protected function message($file) {
        $params = JComponentHelper::getParams('com_jextranet');

        if ($params->get('notify_user_new_vault_file_message', 0) == 0) {
            return;
        }
        $message = new stdclass;
        $message->m_user_id_from = JFactory::getUser()->id;
        $message->m_user_id_to = $file->f_created_by;
        $message->m_date_time = JExtranetHelper::getSystem()->getDateToMySQL();
        $message->published = 1;
        $message->m_subject = $this->tags_replace(
            $params->get('notify_user_new_vault_file_subject', ''), $file
        );
        $message->m_message = $this->tags_replace(
            $params->get('notify_user_new_vault_file_body', ''), $file
        );
        $table = $this->getModel()->getTable('Exmessage', 'JextranetTable', array());
        $table->save($message);
    }

    protected function tags_replace($text, $file) {
        $replacements = array(
            '{{filename}}' => $file->f_title,
            '{{filesize}}' => JExtranetHelper::getSystem()->parseSize($file->f_size),
            '{{filetype}}' => $file->f_type, 
        );
        foreach ($replacements as $tag => $value) {
            $text = str_replace($tag, $value, $text);
        }

        return $text;
    }

    public function getItemsAjax()
    {
		JSession::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));
        $user = JFactory::getApplication()->input->get('user',0,'int');
        $files = JExtranetHelper::getUser($user)->getVaultFiles();
        echo json_encode($files);
        exit();
    }
}
