<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetControllerUsers extends JControllerAdmin {
	
	protected	$option 		= 'com_jextranet';
	protected 	$text_prefix	= 'COM_JEXTRANET_USERS';
	
	public function getModel($name = 'User', $prefix = 'JExtranetModel', $config = array('ignore_request' => true)) {
		$model = parent::getModel($name, $prefix, $config);
		return $model;
	}
	
	
	/*
	 * Method to add new user after the user was choosed
	 * 
	 * name: 		donew
	 * @param
	 * @return
	 */
	public function donew () 
	{
		$app		= JFactory::getApplication();
		$users 		= $app->input->get('user',array(),'array');
		$state 		= $app->input->get('state', 1, 'int' );
		$perm 		= $app->input->get('permissions', array(), 'array');
		$group 		= $app->input->get('group', 0, 'int');
		
		if ( !$users ) 
		{
			$this->setRedirect( 'index.php?option=com_jextranet&view=users', JText::_('COM_JEXTRANET_USERS_ERROR_NO_USER_SELECTED'), 'warning' );
		} 
		else 
		{
			$model = $this->getModel();
			$model->donew ($users, $state, $perm, $group);
			$this->setRedirect( 'index.php?option=com_jextranet&view=users', JText::_('COM_JEXTRANET_USERS_ADDED'), 'message' );
		}
	}

	
	
	/*
	 * Method to authorise an user to access the extranet
	 * 
	 * name: 		unblock ()
	 * @param
	 * @return
	 */
	public function unblock () {
		
		JRequest::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		
		$ids = JRequest::getVar('cid', array(), '', 'array');
		
		if (empty($ids)) {
			$url = 'index.php?option=com_jextranet&view=users';
			$this->setRedirect( $url, JText::_('COM_JEXTRANET_USERS_ERROR_NO_USER_SELECTED'), 'warning' );
		 } else {
			$model 	= $this->getModel();
			$model->unblock($ids);
			$url 	= 'index.php?option=com_jextranet&view=users';
			$this->setRedirect( $url, JText::_('COM_JEXTRANET_USERS_SUCC_AUTHORISED'), 'message' );
		 }
	}


	/*
	 * Method to unauthorise an user to access the extranet
	 * 
	 * name: 		unblock ()
	 * @param
	 * @return
	 */
	public function block () {
		
		JRequest::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		
		$ids = JRequest::getVar('cid', array(), '', 'array');
		
		if (empty($ids)) {
			$url = 'index.php?option=com_jextranet&view=users';
			$this->setRedirect( $url, JText::_('COM_JEXTRANET_USERS_ERROR_NO_USER_SELECTED'), 'warning' );
		 } else {
			$model 	= $this->getModel();
			$model->block($ids);
			$url 	= 'index.php?option=com_jextranet&view=users';
			$this->setRedirect( $url, JText::_('COM_JEXTRANET_USERS_SUCC_UNAUTHORISED'), 'message' );
		 }
	
	}
	
	
	/*
	 * Method to view logs for a user
	 * 
	 * name: 		donew
	 * @param
	 * @return
	 */
	public function logs () {
		
		JRequest::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		
		$ids = JRequest::getVar('cid', array(), '', 'array');
		
		if ( empty($ids) ) {
			$this->setRedirect( 'index.php?option=com_jextranet&view=users', JText::_('COM_JEXTRANET_USERS_ERROR_NO_USER_SELECTED'), 'warning' );
		} else {
			$this->setRedirect( 'index.php?option=com_jextranet&view=userlogs&id=' . (int) $ids[0] );
		}
	
	}
	
	
	public function fileview () {
		
		JRequest::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		
		$ids = JRequest::getVar('cid', array(), '', 'array');
		
		if ( empty($ids) ) {
			$this->setRedirect( 'index.php?option=com_jextranet&view=users', JText::_('COM_JEXTRANET_USERS_ERROR_NO_USER_SELECTED'), 'warning' );
		} else {
			$this->setRedirect( 'index.php?option=com_jextranet&view=userfiles&id=' . (int) $ids[0] );
		}
	
	}

	/**
	 * bulkpermissions :: Void -> Void
	 * redirect user to bulk permissions page
	 * @return void
	 */
	public function bulkpermissions()
	{
		JRequest::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		$this->setRedirect( 'index.php?option=com_jextranet&view=bulkpermissions');
	}
	
}
