<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
/*
 * 	CLI method to sync files in J!Extranet
 *
 */

if (array_key_exists('REQUEST_METHOD', $_SERVER)) die();

// We are a valid entry point.
const _JEXEC = 1;


$base 	= dirname(dirname(dirname(dirname(dirname(dirname(__FILE__))))));

// Load system defines
if (file_exists($base . '/defines.php'))
{
	require_once $base . '/defines.php';
}

if (!defined('_JDEFINES'))
{
	define('JPATH_BASE', $base);
	require_once $base . '/includes/defines.php';
}

// Get the framework.
require_once JPATH_LIBRARIES . '/import.legacy.php';

// Bootstrap the CMS libraries.
require_once JPATH_LIBRARIES . '/cms.php';

// Load the configuration
require_once JPATH_CONFIGURATION . '/configuration.php';

/**
 * A command line cron job to attempt to remove files that should have been deleted at update.
 *
 * @package  Joomla.CLI
 * @since    3.0
 */
class SyncCli extends JApplicationCli
{
	/**
	 * Entry point for CLI script
	 *
	 * @return  void
	 *
	 * @since   3.0
	 */
	public function doExecute()
	{
		// Import the dependencies
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		$jextranet_base	= '/administrator/components/com_jextranet';

		if(!defined('JPATH_COMPONENT')) {
			define('JPATH_COMPONENT', JPATH_CONFIGURATION . $jextranet_base);
		}

		if(!defined('JPATH_COMPONENT_ADMINISTRATOR')){
            define('JPATH_COMPONENT_ADMINISTRATOR', JPATH_CONFIGURATION .
                                                            $jextranet_base);
		}

		require_once JPATH_COMPONENT_ADMINISTRATOR . '/helpers/sync.php';
		require_once JPATH_COMPONENT_ADMINISTRATOR . '/helpers/jextranet.php';

		$sync = new JExtranetSync();
		$sync->run();
	}
} 
 
JApplicationCli::getInstance('SyncCli')->execute();die();
