<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Copyright (C) 2011 Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');
jimport('joomla.utilities.date');

class JExtranetHelper
{

	protected $_db;
	protected static $system;

	
	public function __construct () {
		$this->_db = JFactory::getDbo();
	}
	

	public static function getSystem () {
		
		require_once ( JPATH_COMPONENT . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'jextranet.system.php' );
		
		if (!isset( self::$system )) {
			 self::$system = new JExtranetHelperSystem ();
		}
		return self::$system;
	}


	public static function getAlerter ( $data ) {
		
		require_once ( JPATH_COMPONENT . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'jextranet.alerter.php' );

		$alerter = new JExtranetHelperAlerter ( $data );
		return $alerter;
	}


	// $id - folder ID or ftp location fd_name_ftp
	public static function getFolder ( $id ) {
		
		require_once ( JPATH_COMPONENT . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'jextranet.folders.php' );
		
		$pattern = '/[^0-9]{1,}/';
		if( preg_match( $pattern, $id ) ) {
			$id 	= base64_decode($id);
			$query = JFactory::getDbo()->getQuery(true);
			$query->select('fd_id');
			$query->from('#__extranet_folders');
			$query->where( 'fd_name_ftp  = ' . JFactory::getDbo()->quote( $id ) );
			JFactory::getDbo()->setQuery( $query );
			$id = JFactory::getDbo()->loadResult();
		}
		$folder = JExtranetHelperFolder::getInstance ( $id );
		return $folder ;
	}


	public static function getUser ( $user ) {
		
		require_once ( JPATH_COMPONENT . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'jextranet.user.php' );
		
		$myuser = new JExtranetHelperUser ( $user );
		return $myuser;
	}


	public static function getFile ( $id ) {
		
		require_once ( JPATH_COMPONENT . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'jextranet.file.php' );
		
		$file = new JExtranetHelperFile ( $id );
		return $file;
	}
	
}
