<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetModelMessage extends JModelAdmin
{

	protected $text_prefix = 'COM_JEXTRANET_MESSAGE';

	public function getTable($type = 'Exmessage', $prefix = 'JExtranetTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	public function getForm($data = array(), $loadData = true)
	{
		
		$mid = JRequest::getVar('m_id', 0);
		

		$form = ($mid) ? $this->loadForm('com_jextranet.message', 'message_view', array('control' => 'jform', 'load_data' => $loadData)) : $this->loadForm('com_jextranet.message', 'message_new', array('control' => 'jform', 'load_data' => $loadData));

		if (empty($form)) {
			return false;
		}
		
		return $form;
	}

	protected function loadFormData()
	{
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_jextranet.edit.message.data', array());

		if (empty($data)) {
			$data = $this->getItem();
		}
		
		return $data;
	}

	protected function prepareTable( $table ) {
		
		if (empty($table->m_id)) {
			
			// set creation date
			$table->m_date_time = JExtranetHelper::getSystem()->getDateToMySQL();
		}	
	}
	
	
	public function save($data) {
	
		if (empty($data['m_id'])) 
		{
			$data = JFactory::getApplication()->input->get('jform', array(), 'array');
            $notify = JRequest::getVar ('sendmail','','post','boolean');

            $users = $this->extract_users($data);

			if(empty($users))
			{
				return false;
			}
			
			sort($users);

			
			$data['m_user_id_to'] = json_encode($users);
		}

		if (parent::save($data)) 
		{
            $this->email($users, $data, $notify);
			return true;
		}
		return false;
	}
	
    protected function extract_users($data) {
        $users = array();

        if (empty($data['m_user_id_to']) && empty($data['group']))
        {
            return $users;
        }

        if (!empty($data['group']))
        {
            foreach ($data['group'] as $id)
            {
                if ($id)
                {
                    $group = JExtranetHelper::getSystem()->getGroupUsers($id);
                    $users = array_merge($users, $group);
                }
            }
        }

        if (!empty($data['m_user_id_to']))
        {
            $users = array_merge($users, $data['m_user_id_to']);
        }

        $users = array_unique($users);
        return $users;
    }

    protected function email($users, $data, $notify = false) {
        $params = JComponentHelper::getParams('com_jextranet');
        $receiver = null;
        $receivers = array();

        if (!$notify) {
            return;
        }

        $email 	= JFactory::getApplication('administrator')->getCfg('mailfrom');
        $sender = JFactory::getApplication('administrator')->getCfg('fromname');
        $receiver = JFactory::getUser(array_shift($users))->email;
        $receivers = array_map(function($k){
                        return JFactory::getUser($k)->email;
                    }, $users);
        $subject = $this->tags_replace(
            $params->get('notify_admin_new_message_subject', $data['m_subject']), $data
        );
        $body = nl2br($this->tags_replace(
            $params->get('notify_admin_new_message_body', $data['m_message']), $data
        ));

        $method_used = $params->get('multipleEmailsMethod', 0);
        if ($method_used == 1) {
            $cc = $receivers;
            $bcc = null;
        } else {
            $cc = null;
            $bcc = $receivers;
        }

        JFactory::getMailer()->sendMail(
            $email, $sender, $receiver, $subject, $body, true, $cc, $bcc
        );
    }
	
    protected function tags_replace($text, $message) {
        $replacements = array(
            '{{subject}}' => $message['m_subject'],
            '{{message}}' => $message['m_message'],
            '{{date}}' => JExtranetHelper::getSystem()->getDateToMySQL(),
        );
        foreach ($replacements as $tag => $value) {
            $text = str_replace($tag, $value, $text);
        }

        return $text;
    }

	public function setStatus ()
	{
		$id = JRequest::getVar('m_id','','','int');
		if ($id) 
		{
			$message = $this->getTable();
			$message->load( $id );
			if ( $message->m_user_id_to == 1 )
			{
				$message->published = 1;
				$message->store();
			}
		}
	}

}
