<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */


// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetViewAlert extends JViewLegacy
{
	protected $item;
	protected $form;
	protected $state;
	protected $json;

	public function display($tpl = null)
	{
		$this->state		= $this->get('State');
		$this->item			= $this->get('Item');
		$this->form			= $this->get('Form');
        $this->json         = $this->getModel()->getJsonItems(0, 0);

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		$this->addToolbar();
		parent::display($tpl);
	}

	protected function addToolbar() {

        JHtml::_('script', 'https://cdn.jsdelivr.net/npm/vue@2.6.14/dist/vue.js');
        JHtml::stylesheet(
            'administrator/components/com_jextranet/assets/css/default.css');

		$user		= JFactory::getUser();
		$isNew		= ($this->item->a_id == 0);
		$canDo		= JExtranetHelper::getSystem()->getActions();

		if ($isNew) {
			JToolBarHelper::title(JText::_('COM_JEXTRANET_ADD'), 'flag' );
		} else {
			JToolBarHelper::title(JText::_('COM_JEXTRANET_EDIT'), 'flag' );
		}

		// If not checked out, can save the item.
		if ($canDo->get('core.edit')||($canDo->get('core.create'))){
			JToolBarHelper::apply('alert.apply', 'JTOOLBAR_APPLY');
			JToolBarHelper::save('alert.save', 'JTOOLBAR_SAVE');
		}
		if ($canDo->get('core.create')){
            JToolBarHelper::custom('alert.save2new','save-new.png',
                'save-new_f2.png', 'JTOOLBAR_SAVE_AND_NEW', false);
		}
		// If an existing item, can save to a copy.
		if ($canDo->get('core.create')){
            JToolBarHelper::custom('alert.save2copy','save-copy.png',
                'save-copy_f2.png', 'JTOOLBAR_SAVE_AS_COPY', false);
		}

		if ($isNew){
			JToolBarHelper::cancel('alert.cancel','JTOOLBAR_CANCEL');
		} else {
			JToolBarHelper::cancel('alert.cancel', 'JTOOLBAR_CLOSE');
		}
	}
}
?>
