<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetViewBulkpermissions extends JViewLegacy
{
	protected $item;
	protected $state;
	protected $folders;
	protected $params;
	protected $users;

	public function display($tpl = null)
	{
		$this->state		= $this->get('State');
		$this->item			= $this->get('Item');
		$this->folders		= JExtranetHelper::getFolder(0)->getSubfolders( true );
		$this->params		= JComponentHelper::getParams('com_jextranet');
		$this->users 		= JExtranetHelper::getSystem()->getUsers();

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		$this->addToolbar();
		parent::display($tpl);
	}

	protected function addToolbar() 
	{
		JHtml::stylesheet( 'administrator/components/com_jextranet/assets/css/default.css' );	
		$canDo		= JExtranetHelper::getSystem()->getActions();
		
		JToolBarHelper::title(JText::_('COM_JEXTRANET_BULK_PERMISSIONS'), 'users');	
		
		if ($canDo->get('core.create')) {
			$bar = JToolBar::getInstance('toolbar');
			JHtml::_('bootstrap.modal', 'collapseModal');
			$title = JText::_('JTOOLBAR_APPLY');
			$dhtml = "<button class=\"btn btn-small\" onclick=\"bulky();return false;\"><i class=\"icon-save\"></i>$title</button>";
			$bar->appendButton('Custom', $dhtml, 'SAVE');
		}
		
		JToolBarHelper::cancel('bulkpermissions.cancel', 'JTOOLBAR_CLOSE');
	}
}

