<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

JHtml::_('behavior.tooltip');
JHtml::_('behavior.formvalidation');
JHtml::_('behavior.keepalive');
JHtml::_('behavior.modal');
JHtml::_('dropdown.init');

$here = base64_encode('index.php?option=com_jextranet&task=folder.edit&fd_id=' . $this->item->fd_id);
?>

<script type="text/javascript">
	Joomla.submitbutton = function(task)
	{
		if (task == 'folder.cancel' || task == 'folder.paste' || document.formvalidator.isValid(document.id('folder-form'))) {
			Joomla.submitform(task, document.getElementById('folder-form'));
		} else {
			alert('<?php echo $this->escape(JText::_('JGLOBAL_VALIDATION_FORM_FAILED'));?>');
		}
	}
	
	var folderData = {
		Token: '<?php echo JSession::getFormToken();?>',
		Lang: ["<?php echo JText::_('COM_JEXTRANET_FOLDERS_DELETE_CONFIRM');?>"],
		Folders: <?php echo json_encode( $this->folders );?>,
		Files: <?php echo json_encode( $this->files );?>,
	};
</script>

	<div class="<?php echo $this->item->fd_id ? 'span4' : 'span3';?>">
		<p class="text-center size64"><i class="icon icon-folder"></i></p>
		
		<div class="folder-label">
			<h3 class="pull-left"><?php echo $this->item->fd_id ? $this->escape($this->item->fd_name) : JText::_('COM_JEXTRANET_ADD'); ?></h3>
			
			<?php if ( $this->item->fd_id ) { ?>
			<span class="pull-right">
				<a class="pull-left jextranet-actions" href="#" onclick="toggleUploader();"><i class="icon icon-upload"></i> <span><?php echo JText::_('COM_JEXTRANET_FILES_NEW');?></span></a>
				<a class="pull-left jextranet-actions" href="#addNew" role="button" data-toggle="modal"><i class="icon icon-folder"></i> <span><?php echo JText::_('COM_JEXTRANET_FOLDERS_CREATE_SUBFOLDER');?></span></a>
			</span>
			<?php } ?>
		</div>
		
		<?php if ( $this->item->fd_id ) { ?>
		<!-- add multi files -->
		<div class="row-fluid" id="uploader" style="display:none;">
			<div class="span12 uploadx" style="position:relative; min-height:250px;">
					<div id="upload" class="span5 pull-left" style="border:2px dashed #2552A3; height:200px;"></div>
					<div id="uploaded" class="span6 pull-left" style="border: 1px solid #ddd; height:200px; background:#ecf0f1; color:#2c3e50;overflow:auto;"></div>
			</div>
		</div>
		<!-- /add multi files -->
		<?php } ?>
	</div>
	
	<div class="span1"></div>
			
	<!-- folder editing -->
	<div class="<?php echo $this->item->fd_id ? 'span6' : 'span7';?>">
		<form action="<?php echo JRoute::_('index.php?option=com_jextranet&view=folder&layout=edit&fd_id='.(int) $this->item->fd_id); ?>" method="post" name="adminForm" id="folder-form" class="form-validate form-horizontal">
		<?php $fields = array ('fd_name', 'fd_parent', 'fd_name_ftp', 'fd_description', 'fd_type', 'published'); ?>
		
		<?php foreach ( $fields as $field ) { ?>

			<?php if ( $field == 'fd_name_ftp' ) { ?>
				<?php if ( $this->item->fd_id ) { ?>
					<div class="control-group">
						<div class="control-label">
							<?php echo $this->form->getLabel('fd_name_ftp'); ?>
						</div>
						<div class="controls">
							<?php echo $this->form->getInput('fd_name_ftp'); ?>
						</div>
					</div>
				<?php } ?>
			<?php } else { ?>

			<div class="control-group">
				<div class="control-label">
					<?php echo $this->form->getLabel( $field ); ?>
				</div>
				<div class="controls">
					<?php echo $this->form->getInput( $field ); ?>
				</div>
			</div>
			<?php } } ?>

			<?php echo $this->form->getInput( 'fd_created' ); ?>
			<?php echo $this->form->getInput( 'fd_id' ); ?>
			
			<?php echo $this->loadTemplate('duplicate') ; ?>


			<!-- add new subfolder modal -->
			<div class="modal fade hide" id="addNew" tabindex="-1" role="dialog" aria-labelledby="addNewLabel" aria-hidden="true">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
					<h3 id="addNewLabel"><?php echo JText::sprintf(JText::_('COM_JEXTRANET_FOLDERS_ADD_NEW_FOLDER_INSIDE'), $this->escape($this->item->fd_name));?></h3>
				</div>
				
				<div class="modal-body">
					<div id="return-errors"></div>
					<?php echo $this->loadTemplate('add') ; ?>
				</div>
				
				<div class="modal-footer">
					<button class="btn" data-dismiss="modal" aria-hidden="true"><?php echo JText::_('COM_JEXTRANET_CANCEL');?></button>
					<button class="btn btn-primary" onclick="addFolder();return false;"><?php echo JText::_('COM_JEXTRANET_ADD');?></button>
				</div>
			</div>
			<!-- /add new subfolder modal -->

			<input type="hidden" name="cp_file_to_folder" id="cff" value="" />
			<input type="hidden" name="fd_parent_orig" value="<?php echo $this->item->fd_parent;?>" />
			<input type="hidden" name="task" value="" />
			<?php echo JHtml::_('form.token'); ?>
		</form>
	</div>
	<!-- /folder editing -->
	
	
	<div class="row-fluid">
		<div class="span12">
			
			<?php if ( $this->item->fd_id ) { ?> 
			<ul class="nav nav-pills">
				<?php foreach ($this->route as $route) { ?> 
					<?php if (  $route->id ) { ?>
						<li class="dropdown">
							<a id="drop<?php echo $route->id;?>" class="dropdown-toggle" href="#" data-toggle="dropdown" role="button">
								<i class="icon icon-folder"></i> <?php echo $this->escape($route->name);?>
								<span class="divider"> / </span>
								<b class="caret"></b>
							</a>
							<ul id="menu<?php echo $route->id;?>" class="dropdown-menu" role="menu" aria-labelledby="drop<?php echo $route->id;?>">
								<li role="presentation">
									<a role="menuitem" href="index.php?option=com_jextranet&task=folder.edit&fd_id=<?php echo $route->id;?>">
										<?php echo $this->escape($route->name);?>
									</a>
								</li>
								<?php if ( $route->same ) { foreach ( $route->same as $simbling ) {?>
								<li role="presentation">
									<a role="menuitem" href="index.php?option=com_jextranet&task=folder.edit&fd_id=<?php echo $simbling->id;?>">
										<?php echo $this->escape($simbling->name);?>
									</a>
								</li>
								<?php } } ?>
							</ul>
						</li>
					<?php } else {?>
						<li class="dropdown">
							<a class="dropdown-toggle" href="#" data-toggle="dropdown" role="button"><?php echo JText::_('COM_JEXTRANET_FOLDERS_CURRENT_PATH') ; ?><span class="divider"> / </span></a>
						</li>
					<?php } ?>
				<?php } ?> 
				<li class="active dropdown">
					<a id="drop0" class="dropdown-toggle" href="#" data-toggle="dropdown" role="button">
						<i class="icon icon-folder"></i> <?php echo $this->escape($this->item->fd_name); ?>
						<b class="caret"></b>
					</a>
					<ul id="menu0" class="dropdown-menu" role="menu" aria-labelledby="drop0">
						<li role="presentation">
							<a role="menuitem" href="index.php?option=com_jextranet&task=folder.edit&fd_id=<?php echo $this->item->fd_id;?>">
								<?php echo $this->escape($this->item->fd_name);?>
							</a>
						</li>
					<?php $same = JExtranetHelper::getFolder($this->item->fd_id)->getSameLevel( $this->item->fd_parent, $this->item->fd_id ); if ( $same ) { foreach ( $same as $simbling ) {?>
						<li role="presentation">
							<a role="menuitem" href="index.php?option=com_jextranet&task=folder.edit&fd_id=<?php echo $simbling->id;?>">
								<?php echo $this->escape($simbling->name);?>
							</a>
						</li>
					<?php } } ?>
					</ul>
				</li>
			</ul>
			<?php } ?>
			
			<div class="alert alert-info" id="fcopied" style="display:none;">
				<p><?php echo JText::_('COM_JEXTRANET_FILE_COPIED');?></p>
			</div>

			<!-- folder content -->	
			<table class="table table-striped table-hover">
				<thead>
					<tr>
						<th class="span6">
							<p class="dropdown">
								<a  href="javascript:void(0);" onclick="toggleSearch();">
									<span style="text-transform: uppercase"><?php echo JText::_('COM_JEXTRANET_FOLDERS_CONTENT');?></span>
									<b class="caret"></b>
								</a>
							</p>
							<div id="searchDiv" style="display: none;">
								<input class="input-large pull-left" id="search" type="text" placeholder="<?php echo JText::_('COM_JEXTRANET_SEARCH_BY_NAME') ; ?>" />
								<button class="btn pull-left" type="button" data-bind="click: $root.search; return false;"><?php echo JText::_('JSEARCH_FILTER_SUBMIT');?></button>
								<button class="btn pull-left" type="button" data-bind="click: $root.clear;return false;"><?php echo JText::_('JSEARCH_FILTER_CLEAR');?></button>
							</div>
						</th>
						<th class="span1 text-center"><?php echo JText::_('COM_JEXTRANET_ORDER');?></th>
						<th class="span1 text-center"><?php echo JText::_('COM_JEXTRANET_MOVE_TO');?></th>
						<th class="span1 text-center"><?php echo JText::_('COM_JEXTRANET_LOGS');?></th>
						<th class="span1 text-center"><?php echo JText::_('COM_JEXTRANET_USERS_FOLDER_PERMISSIONS_3');?></th>
						<th class="span1 text-center"><?php echo JText::_('COM_JEXTRANET_DELETE');?></th>
					</tr>
					<tr>
						<th colspan="6">
							
							<?php if ( $this->item->fd_parent ) { ?>
								<a href="index.php?option=com_jextranet&task=folder.edit&fd_id=<?php echo $this->item->fd_parent;?>"><?php echo JText::_('COM_JEXTRANET_FOLDERS_UP_ONE_LEVEL');?></a>
							<?php } ?>
						</th>
					</tr>
				</thead>
				<tbody data-bind="foreach: fisiere">
				<tr data-bind="if: visible()">
					<td class="folders-files">
						<span class="folders-filetype" data-bind="text: type() == 'directory' ? '' : type()"></span>
						<span data-bind="css: isFolder()"></span> 
						<a data-bind="attr: { href: url()+'&toReturn=<?php echo $here;?>' }"><span data-bind="text: title()"></span></a> 
					</td>
					<td>
						<span class="separator pull-left"><a href="#" data-bind="click: $root.moveDown"><i class="icon icon-chevron-down"></i></a></span>
						<span class="separator pull-left"><a href="#" data-bind="click: $root.moveUp"><i class="icon icon-chevron-up"></i></a></span>
					</td>
					<td><a href="javascript:void(0);" onclick="copyfisier(this);" data-bind="click: type() == 'directory' ? '' : $root.copyfisier"><i data-bind="attr:{ class: type() == 'directory' ? '' : 'icon icon-out'}"></i></a></td>
					<td><span data-bind="if: type() != 'directory'"><a data-bind="attr: { href: 'index.php?option=com_jextranet&task=filelogs.viewlog&toReturn=<?php echo $here;?>&id='+id() }"><i class="icon icon-eye-open"></i></a></span></td>
					<td><span data-bind="if: type() != 'directory'"><a data-bind="attr: { href: 'index.php?option=com_jextranet&task=file.download&id='+id() }"><i class="icon icon-download"></i></a></span></td>
					<td><a href="#" data-bind="click: $root.removeFisier"><i class="icon-trash icon"></i></a></td>
				</tr>
				</tbody>
			</table>
		<!-- /folder content -->
		</div>
	</div>

	
	
<script type="text/javascript" src="//ajax.aspnetcdn.com/ajax/knockout/knockout-3.0.0.js"></script>
<script type="text/javascript" src="components/com_jextranet/assets/knock.js/itemViewModel.js"></script>
<script type="text/javascript" src="components/com_jextranet/assets/knock.js/listViewModel.js"></script>
<script type="text/javascript" src="components/com_jextranet/assets/knock.js/folder.js"></script>

<script type="text/javascript">
	
	function copyfisier(el) {
		document.getElementById('fcopied').style.display = 'block';
		el.innerHTML = '<i class="icon icon-save"></i>';
	}

	function toggleUploader() {
		var uploader = document.getElementById('uploader');
		if ( uploader.style.display == 'none' ) {
			uploader.style.display = 'block'; 
		} else {
			uploader.style.display = 'none' ;
		}
	}

	function toggleSearch() {
		var uploader = document.getElementById('searchDiv');
		if ( uploader.style.display == 'none' ) {
			uploader.style.display = 'block'; 
		} else {
			uploader.style.display = 'none' ;
		}
	}
	
	jQuery().ready(function() {

		var errors="";
		var files ="";
		
		jQuery('#upload').mfupload({
			
			type		: '',	//all types
			maxsize		: '5000',
			post_upload	: "<?php echo JUri::root();?>administrator/index.php?option=com_jextranet&task=multiple.upload&tmpl=component&folder=<?php echo $this->item->fd_id;?>&<?php echo JSession::getFormToken();?>=1",
			folder		: "<?php echo $this->item->fd_id;?>",
			ini_text	: "<?php echo JText::_(sprintf(JText::_('COM_JEXTRANET_MULTI_UPLOAD_DRAG_FILE'), $this->escape($this->item->fd_name)));?>",
			over_text	: "<?php echo JText::_('COM_JEXTRANET_MULTI_UPLOAD_DROP_HERE');?>",
			over_col	: 'white',
			over_bkcol	: '#27ae60',
			
			init		: function(){		
				jQuery("#uploaded").empty();
			},
			
			start		: function(result){		
				jQuery("#uploaded").append("<div id='FILE"+result.fileno+"' class='files'>"+result.filename+"<div id='PRO"+result.fileno+"' class='progress'></div></div>");	
			},

			loaded		: function(result){
				jQuery("#PRO"+result.fileno).remove();
				jQuery("#FILE"+result.fileno).html("<i class='icon icon-file'></i> <?php echo JText::_('COM_JEXTRANET_MULTI_UPLOAD_UPLOADED');?>: "+result.filename+" ("+result.size+")");	
				if ( result.error ) {
					jQuery("#FILE"+result.fileno).html("<?php echo JText::_('COM_JEXTRANET_MULTI_UPLOAD_ERRORS');?>: "+result.error);	
				}
				files = result.filename+','+files;	
			},

			progress	: function(result){
				jQuery("#PRO"+result.fileno).css("width", result.perc+"%");
			},

			error		: function(error){
				errors += error.filename+": "+error.err_des+"\n";
			},

			completed	: function( result ){
				if (errors != "") {
					alert(errors);
					errors = "";
				}
				myView.change( result );
				sendNotification( files );
				files = '';
			}	
		});   	
	});


	function addFolder() {
	
		var fd_name 		= jQuery('#fd_name').val(); 
		var fd_published	= jQuery('#fd_published').val(); 
		var fd_type			= jQuery('#fd_type').val(); 
		var fd_parent		= jQuery('#fd_parent').val(); 
	
		jQuery.ajax({
				type: "POST",
				url: "index.php?option=com_jextranet&task=folder.saveAjax&<?php echo JSession::getFormToken();?>=1",
				data: { name: fd_name, published: fd_published, type: fd_type, parent: fd_parent }
			})
			.done(function( msg ) {
				var x = jQuery.parseJSON(msg);
		
				if ( x.error ) {
					jQuery('#return-errors').addClass('alert alert-error');
					jQuery('#return-errors').html( x.error );
				} else {
					jQuery('#addNew').modal('hide');
					myView.change( x );
					jQuery('#fd_name').val('')
				}
			});
		}
		
	
	function sendNotification( files ) {
		jQuery.ajax({
			type: "POST",
			url: "index.php?option=com_jextranet&task=multiple.sendNotification&<?php echo JSession::getFormToken();?>=1",
			data: { folder: '<?php echo $this->item->fd_id;?>', files: files }
		});
	}
</script>

