<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */


// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetViewGroup extends JViewLegacy
{
	protected $item;
	protected $form;
	protected $state;
	protected $json;

	public function display($tpl = null)
	{
		$this->state	= $this->get('State');
		$this->item		= $this->get('Item');
		$this->form		= $this->get('Form');
        $this->json     = $this->getModel()->permissionsJsonData(0,0,
                                                    $this->item->g_id);

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		$this->addToolbar();
		parent::display($tpl);
	}

	protected function addToolbar() {

        JHtml::_('script', 'https://cdn.jsdelivr.net/npm/vue@2.6.14/dist/vue.js');
        JHtml::stylesheet(
            'administrator/components/com_jextranet/assets/css/default.css');

		$user		= JFactory::getUser();
		$canDo		= JExtranetHelper::getSystem()->getActions();
		$isNew		= ($this->item->g_id == 0);

		if ($isNew) {
            JToolBarHelper::title('J!Extranet :: '.
                                    JText::_( 'COM_JEXTRANET_ADD' ), 'users');
		} else {
            JToolBarHelper::title('J!Extranet :: '.
                                    JText::_( 'COM_JEXTRANET_EDIT' ), 'users');
		}

		// If not checked out, can save the item.
		if ($canDo->get('core.edit')||($canDo->get('core.create'))) {
			JToolBarHelper::apply('group.apply', 'JTOOLBAR_APPLY');
			JToolBarHelper::save('group.save', 'JTOOLBAR_SAVE');
		}

		if (empty($this->item->g_id))  {
			JToolBarHelper::cancel('group.cancel','JTOOLBAR_CANCEL');
		} else {
			JToolBarHelper::cancel('group.cancel', 'JTOOLBAR_CLOSE');
		}
	}
}
?>
