<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetViewMessages extends JViewLegacy
{
	protected $items;
	protected $pagination;
	protected $state;

	function display($tpl = null) {
		
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->state		= $this->get('State');
		
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		
		$this->addToolbar();

		JExtranetHelper::getSystem()->addSubmenu ('messages');
		$this->sidebar = JHtmlSidebar::render();

		parent::display($tpl);
		
	}
	
	public function addToolbar() {	
		
		JHtml::stylesheet( 'administrator/components/com_jextranet/assets/css/default.css' );

		$canDo	= JExtranetHelper::getSystem()->getActions();
		
		JToolBarHelper::title(   'J!Extranet :: ' . JText::_( 'COM_JEXTRANET_MESSAGES' ), 'envelope' );	
		
		if ($canDo->get('core.create')) {
			JToolBarHelper::addNew('message.add', 'JTOOLBAR_NEW');
		}

		if ($canDo->get('core.edit')) {
			JToolBarHelper::custom('message.edit', 'envelope', 'envelope', 'COM_JEXTRANET_READ' , true);
		}
		
		if ($canDo->get('core.delete')) {
			JToolBarHelper::custom('messages.delete', 'delete.png', 'delete.png', 'JTOOLBAR_DELETE' , true);
		}

		if ($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_jextranet');
		}		
	}
	
}
?>
