<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetViewStatistics extends JViewLegacy
{
	protected $items;
	protected $published;
	protected $files;
	protected $userfiles;
	protected $folders;
	protected $groups;
	protected $readm;
	protected $unreadm;
	protected $f_file;
	protected $f_filetype;

	function display($tpl = null) {
		
		$this->published		= $this->get('TotalPublished');
		$this->files			= $this->get('TotalFiles');
		$this->userfiles		= $this->get('TotalUserFiles');
		$this->folders			= $this->get('TotalFolders');
		$this->groups			= $this->get('TotalGroups');
		$this->readm			= $this->get('TotalMessagesP');
		$this->unreadm			= $this->get('TotalMessagesU');
		$this->f_file			= $this->get('FavFile');
		$this->f_filetype		= $this->get('FavType');
		
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		
		$this->addToolbar();

		JExtranetHelper::getSystem()->addSubmenu ('statistics');
		$this->sidebar = JHtmlSidebar::render();

		parent::display($tpl);
		
	}
	
	
	public function addToolbar() {	
		
		JHtml::stylesheet( 'administrator/components/com_jextranet/assets/css/default.css' );

		$canDo	= JExtranetHelper::getSystem()->getActions();
		
		JToolBarHelper::title(   'J!Extranet :: ' . JText::_( 'COM_JEXTRANET_STATISTICS' ) );	
		
		if ($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_jextranet');
		}		
	}
	
}
?>
