<p class="alert alert-info">
<?php echo JText::_('COM_JEXTRANET_BULK_PERMISSIONS_INFO');?></p>

<div id="permissions_template"><permissions inline-template><div>
<div class="row-fluid item" v-show="folder != 0">
    <div class="span12">
        <p><a class="btn" v-on:click="backFolder()">
            <i class="icon-back"></i>
                <?php echo JText::_('COM_JEXTRANET_BACK');?>
            </a>
            <span class="depth" v-for="n in (previous.length - 1)">../</span>
        </p>
    </div>
</div>

<div class="row-fluid item" v-for="(item,index) in items">
    <div class="span6">
        <p>
            <i class="icon-folder"></i>
            <a v-on:click="enterFolder(item.id)">
            {{item.name}}</a>
        </p>
    </div>
    <div class="span5">
        <p>{{ permissions_to_text(item.permissions.mixed) }}</p>
    </div>
    <div class="span1">
        <a v-on:click="toggleItemActive(item)">
            <i v-bind:class="(item.active == 1) ? 'icon-cancel' : 'icon-new'"></i>
        </a>
    </div>
    <div class="row-fluid" v-if="item.active == 1">
        <div class="span12">
            <span class="inline">
                <?php echo JText::_('COM_JEXTRANET_USER_PERMISSIONS');?>
                (<?php echo JText::_('COM_JEXTRANET_MUST_BE_SET_HERE');?>)
            </span>
            <ul class="breadcrumb user">
                <li
                    v-for="perm in permisiuni"
                    v-if="perm.value != 0">
                    <span
                        v-on:click="togglePermission(item,perm.value)"
                        v-bind:class="contains(item.permissions.his, perm.value) ?
                                        'label label-success' : 'label'">
                        <i class="icon-save"></i> {{perm.text}}
                    </span>
                </li>
            </ul>
        </div>
    </div>
    <div class="row-fluid" v-if="item.active == 1">
        <div class="span12">
            <span class="inline">
                <?php echo JText::_('COM_JEXTRANET_GROUP_PERMISSIONS');?>
    (<?php echo JText::_('COM_JEXTRANET_INHERITED_FROM_GROUP_CANNOT_SET');?>)
            </span>
            <ul class="breadcrumb">
                <li
                    v-for="perm in permisiuni"
                    v-if="perm.value != 0">
                    <span
                        v-bind:class="contains(item.permissions.group, perm.value) ?
                                        'label label-success' : 'label'">
                        <i class="icon-save"></i> {{perm.text}}
                    </span>
                </li>
            </ul>
        </div>
    </div>
</div>

<div class="pagination pagination-toolbar">
    <nav>
        <ul v-for="page in pagination_list()" class="pagination-list">
            <li v-bind:class="isPageActive(page.value)">
                <a v-on:click="changePage(page.value)">{{page.text}}</a></li>
        </ul>
    </nav>
</div>

</div></permissions></div>
<script>
Vue.component("permissions",{
    data: function (){ return {
        permisiuni:[
            {'text':'<?php echo JText::_('COM_JEXTRANET_USERS_FOLDER_PERMISSIONS_0', true);?>', 'value':0},
            {'text':'<?php echo JText::_('COM_JEXTRANET_USERS_FOLDER_PERMISSIONS_1', true);?>', 'value':1},
            {'text':'<?php echo JText::_('COM_JEXTRANET_USERS_FOLDER_PERMISSIONS_2', true);?>', 'value':2},
            {'text':'<?php echo JText::_('COM_JEXTRANET_USERS_FOLDER_PERMISSIONS_3', true);?>', 'value':3},
            {'text':'<?php echo JText::_('COM_JEXTRANET_USERS_FOLDER_PERMISSIONS_4', true);?>', 'value':4},
            {'text':'<?php echo JText::_('COM_JEXTRANET_USERS_FOLDER_PERMISSIONS_5', true);?>', 'value':5},
            {'text':'<?php echo JText::_('COM_JEXTRANET_USERS_FOLDER_PERMISSIONS_6', true);?>', 'value':6}
        ],
        selected: 0,
        pages: <?php echo $this->json->pages;?>,
        folder: 0,
        items: <?php echo $this->json->items;?>,
        user: <?php echo $this->item->u_id;?>,
        previous: [{page: 0, id: 0}],
    }},
    methods: {
        togglePermission: function(item, value) {
            var task = this.contains(item.permissions.his, value) ?
                            'unset' : 'set';
            var data = {
                'folder': item.id,
                'permission': value,
                'user':this.user,
                'do': task
            };
            var url = 'index.php?option=com_jextranet&task=user.permission';
            var self = this;
            jQuery.post(url, data, function(response){
                if (response) {
                    var updated = JSON.parse(response);
                    if (item.id == 'all') {
                        self.items = JSON.parse(updated.items);
                        self.pages = updated.pages;
                    } else {
                        item.permissions.his = updated.his;
                        item.permissions.mixed = updated.mixed;
                    }
                }
            });
        },
        toggleItemActive: function(item) {
            item.active = item.active == 0 ? 1 : 0;
        },
        contains: function(list, value) {
            if (list.indexOf(value.toString()) !== -1) {
                return true;
            }
            return false;
        },
        permissions_to_text: function(permisiuni) {
            var self = this;
            translated = permisiuni.map(function(valoare){
                return self.permisiuni[valoare].text;
            });
            return translated.join(', ');
        },
        pagination_list: function() {
            var counter = [];

            if (this.pages > 10) {
                var picked = [];
                picked.push(0);
                picked.push(this.pages-1);

                if (picked.indexOf(this.selected) == -1) {
                    picked.push(this.selected);
                }
                var n_1 = this.selected - 1;
                var n_2 = this.selected - 2;
                var n_3 = this.selected - 3;
                var n_plus_1 = this.selected + 1;
                var n_plus_2 = this.selected + 2;
                var n_plus_3 = this.selected + 3;
                var n_quarter = this.selected - parseInt(this.selected/4);
                var n_plus_quarter = this.selected + parseInt(this.selected/4);
                if (picked.indexOf(n_1) == -1 && n_1 > 0) {
                    picked.push(n_1);
                }
                if (picked.indexOf(n_2) == -1 && n_2 > 0) {
                    picked.push(n_2);
                }
                if (picked.indexOf(n_3) == -1 && n_3 > 0) {
                    picked.push(n_3);
                }
                if (picked.indexOf(n_quarter) == -1 && n_quarter > 0) {
                    picked.push(n_quarter);
                }
                if (picked.indexOf(n_plus_1) == -1 && n_plus_1 < this.pages) {
                    picked.push(n_plus_1);
                }
                if (picked.indexOf(n_plus_2) == -1 && n_plus_2 < this.pages) {
                    picked.push(n_plus_2);
                }
                if (picked.indexOf(n_plus_3) == -1 && n_plus_3 < this.pages) {
                    picked.push(n_plus_3);
                }
                if (picked.indexOf(n_plus_quarter) == -1 &&
                                                n_plus_quarter < this.pages) {
                    picked.push(n_plus_quarter);
                }
                picked.sort(function(a,b){return a-b;});
                picked.forEach(function(value){
                    pagina = {};
                    pagina.text = value + 1;
                    pagina.value = value;
                    counter.push(pagina);
                });
            } else {
                for (var i = 0;i<this.pages; i++) {
                    pagina = {};
                    pagina.text = i+1;
                    pagina.value = i;
                    counter.push(pagina);
                }
            }
            return counter;
        },
        isPageActive: function(selected) {
            if (selected == this.selected) {
                return 'active';
            }
        },
        changePage: function(newpage) {
            this.selected = newpage;
            var data = {
                'parent':this.folder,
                'offset':this.selected,
                'user':this.user
            };
            var url = 'index.php?option=com_jextranet&task=user.getJsonItems';
            var self = this;
            jQuery.post(url, data, function(response){
                var r = JSON.parse(response);
                self.pages = r.pages;
                self.items = JSON.parse(r.items);
            });
        },
        enterFolder: function(id) {
            var current = {'page':this.selected, 'id': this.folder};
            this.previous.push(current);
            this.access(id, 0);
        },
        backFolder: function() {
            if (this.previous.length === 0) {
                return;
            }

            var previous = this.previous.pop();
            this.access(previous.id, previous.page);
        },
        access: function(id, page) {
            this.folder = id;
            var data = {
                'parent' : id,
                'offset' : page,
                'user' : this.user,
            };
            var url = 'index.php?option=com_jextranet&task=user.getJsonItems';
            var self = this;
            jQuery.post(url, data, function(response){
                var r = JSON.parse(response);
                self.pages = r.pages;
                self.items = JSON.parse(r.items);
            });
        },
    },
});
new Vue({ el: "#permissions_template" })
</script>
