<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

JHtml::_('bootstrap.tooltip');

$listOrder	= $this->state->get('list.ordering');
$listDirn	= $this->state->get('list.direction');
$groups	= JExtranetHelper::getSystem()->getGroups ();

?>

<form action="<?php echo JRoute::_('index.php?option=com_jextranet&view=users'); ?>" method="post" name="adminForm" id="adminForm">
	
	<div id="j-sidebar-container" class="span2">
		<?php echo $this->sidebar; ?>
	</div>

	<div id="j-main-container" class="span10">

		<div id="filter-bar" class="btn-toolbar">	
		
			<div class="filter-search btn-group pull-left">
				<input type="text" name="filter_search" id="filter_search" placeholder="<?php echo JText::_('JSEARCH_FILTER_LABEL'); ?>" value="<?php echo $this->escape($this->state->get('filter.search')); ?>" title="" />
			</div>

			<div class="btn-group pull-left">
				<button class="btn tip" type="submit" title="<?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?>"><i class="icon-search"></i></button>
				<button class="btn tip" type="button" title="<?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?>" onclick="document.id('filter_search').value='';this.form.submit();"><i class="icon-remove"></i></button>
			</div>
			
			<div class="btn-group pull-right">
				<select name="filter_group" class="inputbox" onchange="this.form.submit()">
					<option value=""> - <?php echo JText::_('COM_JEXTRANET_USERS_SELECT_GROUP');?> - </option>
					<?php echo JHtml::_('select.options', $groups  , 'value', 'text', $this->state->get('filter.group'));?>
				</select>
			</div>
		
		</div>

		<div class="clr"> </div>
	
		<table class="table table-striped">
			<thead>
				<tr>
				
					<th width="1%">
						<input type="checkbox" name="toggle" value="" onclick="Joomla.checkAll(this)" />
					</th>

					<th width="35%">
						<?php echo JHtml::_('grid.sort', 'COM_JEXTRANET_NAME', 'b.name', $listDirn, $listOrder); ?>
					</th>
					
					<th width="14%">
						<?php echo JHtml::_('grid.sort', 'COM_JEXTRANET_USERS_USERNAME', 'b.username', $listDirn, $listOrder); ?>
					</th>
					
					<th width="10%">
						<?php echo JText::_('COM_JEXTRANET_AUTHORIZED'); ?>
					</th>
					
					<th width="15%">
						<?php echo JText::_('COM_JEXTRANET_USERS_GROUP'); ?>
					</th>
					
					<th width="20%">
						<?php echo JHtml::_('grid.sort', 'COM_JEXTRANET_EMAIL', 'b.email', $listDirn, $listOrder); ?>
					</th>
					
					<th width="5%">
						<?php echo JHtml::_('grid.sort', 'COM_JEXTRANET_ID', 'a.u_id', $listDirn, $listOrder); ?>
					</th>
					
				</tr>
			</thead>

			<tbody>
			<?php foreach ($this->items as $i => $item) {
			?>
			<tr class="row<?php echo $i % 2; ?>">

				<td>
					<?php echo JHtml::_('grid.id', $i, $item->id); ?>
				</td>
				
				<td>
					<a href="index.php?option=com_jextranet&task=user.edit&u_id=<?php echo $item->id;?>"><?php echo $this->escape($item->name);?></a>
				</td>
				
				<td>
					<?php echo $this->escape($item->username);?>
				</td>
				
				<td>
					<span id="blocked">
						<?php echo $item->block ? JHtml::_('jgrid.action', $i, 'users.block', '', '', '', '', '', 'publish') : JHtml::_('jgrid.action', $i, 'users.unblock', '', '', '', '', '', 'unpublish'); ?>
					</span>
				</td>
				
				<td>
					<?php echo JExtranetHelper::getUser( $item->id )->getGroup()->g_name;?>
				</td>
				
				<td>
					<?php echo $this->escape($item->email);?>
				</td>
				
				<td>
					<?php echo $item->id; ?>
				</td>
				
			</tr>

			<?php } ?>
			</tbody>
					
			<tfoot>
				<tr>
					<td colspan="7">
						<?php echo $this->pagination->getListFooter(); ?>
					</td>
				</tr>
			</tfoot>
		</table>

		<?php echo $this->loadTemplate('getusers'); ?>

	</div>
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
		<?php echo JHtml::_('form.token'); ?>
</form>
