<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');



class JExtranetControllerFolders extends JControllerLegacy {
	
	protected	$option 		= 'com_jextranet';
	protected 	$text_prefix	= 'COM_JEXTRANET_FOLDERS';
	
	public function getModel($name = 'Folders', $prefix = 'JExtranetModel', $config = array('ignore_request' => true)) {
		$model = parent::getModel($name, $prefix, $config);
		return $model;
	}
	
	
	// $parent = id of the parent folder where we create the folder
	public function create() {

		$jform		= JRequest::getVar('jform',array(),'','array');
		
		$redirect 	= JRoute::_('index.php?option=com_jextranet&view=folders&fid=' . $jform['folder'], false );

		// check if we have data we need
		if ( empty($jform) || empty($jform['folder']) ) {
			$this->setRedirect( $redirect, JText::_('COM_JEXTRANET_FILE_UPLOAD_INVALID_REQUEST'), 'warning' );
			return;
		}
		
		// check if the user is allowed to create folders
		$levels = JExtranetHelperUser::getInstance()->getAuthorisationLevel ( $jform['folder'] );
		
		if ( !in_array(6,$levels) ) {
			$this->setRedirect( $redirect, JText::_('COM_JEXTRANET_FILE_UPLOAD_INVALID_REQUEST'), 'warning' );
			return;
		}

		$model 		= $this->getModel();
		if ( !$model->create( $jform ) ) {
			$error = $model->getErrors();
			$this->setRedirect( $redirect, $error, 'warning' );
			return;
		}
		$this->setRedirect( $redirect );
		return true;
	}
}

?>
