<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetControllerMessages extends JControllerLegacy {
	
	protected	$option 		= 'com_jextranet';
	protected 	$text_prefix	= 'COM_JEXTRANET_MESSAGES';
	
	public function getModel($name = 'Messages', $prefix = 'JExtranetModel', $config = array('ignore_request' => true)) {
		$model = parent::getModel($name, $prefix, $config);
		return $model;
	}


	public function compose () {
		JRequest::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));
		
		$reply = JFactory::getApplication()->input->get('cid', 0, 'int');
		
		$url = JRoute::_('index.php?option=com_jextranet&view=message&id=0&reply=' . $reply,false);
		$this->setRedirect( $url );
	}
	
	
	public function delete () {
		
		JRequest::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));
		$ids 		= JRequest::getVar('cid', array(),'','array');
		$allowed 	= JComponentHelper::getParams('com_jextranet')->get('canUserDeleteMessages', 0 );

		if (!$allowed) {
			$this->setRedirect( JRoute::_('index.php?option=com_jextranet&view=messages',false), JText::_('COM_JEXTRANET_DELETE_MESSAGE_NO_PERMISSIONS'), 'warning' );
			return;
		}
		
		if (!$ids) {
			$this->setRedirect( JRoute::_('index.php?option=com_jextranet&view=messages',false), JText::_('COM_JEXTRANET_MESSAGES_NO_SELECTED'), 'warning' );
			return;
		}

		JArrayHelper::toInteger($ids);
		$this->getModel()->delete($ids);
		$this->setRedirect( JRoute::_('index.php?option=com_jextranet&view=messages',false) );
		return true;
	}
	
}
