<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');


class JExtranetMenu  {

	public static function getMenu ( $location ) 
	{
		$menu 	= array();
		$params	= JComponentHelper::getParams('com_jextranet');
        $exclude = (!is_array( $params->get('userMenuItemsRemoved', 0))) ?
            array(0) : $params->get('userMenuItemsRemoved', 0);
        $custom_pages = JExtranetHelperUser::getInstance()->getCustomPages();

		$menu[] = '<div class="mmenu"><a href="javascript:void(0);" onclick="toggleMenu();">'.JText::_('COM_JEXTRANET_MENU').'</a></div>';

		$menu[] = '<ul id="side_controls">';

		$class	= ( $location == 'home' ) ? 'class="active"' : '';
		$menu[] = '<li '.$class.'><a href="' . JRoute::_('index.php?option=com_jextranet', false) . '"><i class="ico ico-home"></i><span>'. JText::_('COM_JEXTRANET_HOME').'</span></a></li>';
       
        if (!empty($custom_pages)) {
            foreach ($custom_pages as $idx) {
                $class	= ($location == 'custom_page_' . $idx) ? 'class="active"' : '';
                $menu[] = '<li '.$class.
                    '><a href="' . JRoute::_('index.php?option=com_jextranet&view=custom&id=' . $idx, false).
                    '"><i class="ico ico-custom_page_'.$idx.'"></i><span>'.
                    JText::_('COM_JEXTRANET_CUSTOM_PAGE_' . $idx).
                    '</span></a></li>';
            }
        }

		$class	= ( $location == 'folders' ) ? 'class="active"' : '';		
		$menu[] = '<li '.$class.'><a href="' . JRoute::_('index.php?option=com_jextranet&view=folders', false) .'"><i class="ico ico-folder-alt"></i><span>'. JText::_('COM_JEXTRANET_FOLDERS').'</span></a></li>';		
		
		if(!in_array( 2, $exclude)) 
		{
			$class	= ( $location == 'messages' ) ? 'class="active"' : '';
			$menu[] = '<li '.$class.'><a href="' . JRoute::_('index.php?option=com_jextranet&view=messages', false) .'"><i class="ico ico-speech"></i><span>'. JText::_('COM_JEXTRANET_MESSAGES').'</span></a></li>';		
		}
		
		if(!in_array( 3, $exclude) && $params->get('useBookmarks',1) == 1 ) 
		{
			$class	= ( $location == 'bookmarks' ) ? 'class="active"' : '';
			$menu[] = '<li '.$class.'><a href="' . JRoute::_('index.php?option=com_jextranet&view=bookmarks', false) .'"><i class="ico-pin"></i><span>'. JText::_('COM_JEXTRANET_BOOKMARKS').'</span></a></li>';		
		}
	
		if(!in_array( 4,$exclude)) 
		{
			$class	= ( $location == 'userfiles' ) ? 'class="active"' : '';		
			$menu[] = '<li '.$class.'><a href="' . JRoute::_('index.php?option=com_jextranet&view=userfiles', false) .'"><i class="ico ico-cloud-upload"></i><span>'. JText::_('COM_JEXTRANET_USERFOLDERS').'</span></a></li>';
		}
		
		if ( $params->get('useLogoutButton', 0) == 1 ) 
		{
			$menu[] = '<li>
				<a href="javascript:JExtranetSubmitTask(\'jextranet.logout\');"><i class="ico ico-logout"></i><span>'. JText::_('COM_JEXTRANET_LOGOUT').'</span></a>
			</li>';			
		}
		$menu[] = '</ul>';
		
		return implode ($menu);
	}
}             
