<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.client.helper');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');


class JExtranetModelJextranet extends JModelLegacy
{
	protected $user;

	public function __construct($config = array()) {
		$this->user = JExtranetHelperUser::getInstance();
		parent::__construct($config);
	}
	
	
	public function getFirstpage () {
		$uparams = $this->user->getParams();

		if (!empty($uparams->firstPageContent)) {
			return $uparams->firstPageContent;
		} 

		return JComponentHelper::getParams('com_jextranet')->get( 'firstPageContent', null );
	}
	
	
	public function getLatestFiles() 
	{

		$now = JExtranetHelper::getSystem()->getDateToMySQL();
		$latest = array();

		$query = $this->_db->getQuery( true );
		$query->select('a.f_parent, a.f_title, a.f_created');
		$query->from('#__extranet_files AS a');
		$query->where('(a.f_publish_up = ' . $this->_db->quote('0000-00-00 00:00:00') .' OR a.f_publish_up >= '.$this->_db->quote($now).')' );
		$query->where('(a.f_publish_down = ' . $this->_db->quote('0000-00-00 00:00:00') .' OR a.f_publish_down >= '.$this->_db->quote($now).')' );
		$query->where('a.published = 1');
		$query->order('a.f_id DESC LIMIT 10');

		$this->_db->setQuery($query);
		$results = $this->_db->loadObjectList();

		if(!empty($results)) 
		{
			foreach ($results as $file) 
			{
				$auth = $this->user->getAuthorisationLevel ($file->f_parent); JArrayHelper::toInteger($auth); 
				if (in_array(3, $auth)) 
				{
					$latest[] = $file;
				}
			}
		}

		return $latest;
	}
	
	
	public function getLastLogin() {
		
		$app 			= JFactory::getApplication();
		$lastIP 		= $app->getUserState('jextranet.last.login.ip', null);
		$login_file 	= JPATH_COMPONENT . DIRECTORY_SEPARATOR . 'logs' . DIRECTORY_SEPARATOR . 'last_' . $this->user->get('id');
		
		// if last ip file for this user doesn't exist, create it, and return null for last IP
		if (!JFile::exists($login_file)) {
			$ip	= $this->user->getIP();
			JFile::write( $login_file, $ip );
			$app->setUserState( 'jextranet.last.login.ip', '-' );
			return null; 
		}
		
		// if a last ip file exist, but we don't have set last ip session
		if ( !$lastIP ) {
			$lastIP = JFile::read( $login_file );
			$app->setUserState( 'jextranet.last.login.ip', $lastIP );
			return $lastIP;
		}
	
		return $lastIP;
	}
	
	
	public function getLatestMessages() {
		
		//$disabled 	= JComponentHelper::getParams('com_jextranet')->get( 'userMenuItemsRemoved', array() );
		$user		= JFactory::getUser()->get('id');

		// Create a new query object.
		$query	= $this->_db->getQuery(true);

		// Select the required fields from the table.
		$query->select('a.m_subject AS subject, a.m_id AS id');
		$query->from(' #__extranet_messages AS a');
		$query->where(' (a.m_user_id_to = ' . $user  . '  OR a.m_user_id_to REGEXP \'\"'.$user.'\"\' OR (a.m_user_id_to = 1 AND a.m_user_id_from =' . $user .'))');
		$query->order('a.m_id DESC LIMIT 10');
		
		$this->_db->setQuery( $query );
		return $this->_db->loadObjectList();
	}
	
}
?>
