<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetModelMessage extends JModelList
{
	protected	$option 		= 'COM_JEXTRANET';
	
	public function getMessage() {
		
		$disabled = JComponentHelper::getParams('com_jextranet')->get( 'userMenuItemsRemoved', array() );
		$reply = true;
		
		if ( in_array( 2, $disabled )) 
		{
			return false;
		}

		// first try to get the reply ID, if not check if it's a message ID
		if (!($id = JFactory::getApplication()->input->get('reply', 0, 'int')))
		{
			$reply = false;
			$id = JFactory::getApplication()->input->get('id',0,'int');
		}
		
		$user	= JFactory::getUser()->get('id');
		
		$query = $this->_db->getQuery ( true );
		$query->select('a.m_subject, a.m_message, a.m_user_id_to, a.published, a.m_id AS id, a.m_date_time');
		$query->from('#__extranet_messages AS a');
		$query->where('a.m_id = ' . $id . ' AND (a.m_user_id_to = ' . $user . ' OR a.m_user_id_from = '.  $user .' OR a.m_user_id_to REGEXP \'\"'.$user.'\"\' )');
		$this->_db->setQuery($query);
		$message = $this->_db->loadObject();
		
		// mark as read
		if ($message) 
		{	
			$query->clear();
			$query->update('#__extranet_messages');
			$query->set('published = 1');
			$query->where('m_id = ' . $id);
			$this->_db->setQuery($query);
			$this->_db->query();
		}
		else
		{
			$message = new stdclass;
			$message->id = 0;
			$message->m_subject = '';
			$message->m_message = '';
		} 

		// set the reply flag
		$message->reply = $reply;
		
		return $message;
	}
		
	public function send ($message) {
        $table = $this->getTable('Exmessage', 'JextranetTable', array());
        return $table->save($message);
	}

    public function forward($message) {
        $forward 	=
            JComponentHelper::getParams('com_jextranet')->get('forwardMessage', 0);
        $forwardTo 	=
            JComponentHelper::getParams('com_jextranet')->get('forwardMessageTo', 0);
		
		if ($forward && $forwardTo) {
            JFactory::getMailer()->sendMail(
                JFactory::getUser()->get('email'),
                JFactory::getUser()->get('name'),
                $forwardTo, $subject, $message->m_message, false);
		}
    }

    public function email($message) {
        $params = JComponentHelper::getParams('com_jextranet');
        $enabled = $params->get('notify_user_new_message', 0);

        if (!$enabled) {
            return;
        }

        $receiver = $params->get('notify_user_new_message_to','');
        $receivers = $params->get('notify_user_new_message_cc','');
        $receivers = $receivers ? explode(',', $receivers) : array();
        $subject = $this->tags_replace(
            $params->get('notify_user_new_message_subject', ''), $message
        );
        $body = nl2br($this->tags_replace(
            $params->get('notify_user_new_message_body', ''), $message
        ));
        $sender = JFactory::getConfig()->get('fromname');
        $email = JFactory::getConfig()->get('mailfrom');
        $method = $params->get('multipleEmailsMethod', 0);
        $cc = null;
        $bcc = null;

        if ($method == 1) {
            $cc = $receivers;
        } else {
            $bcc = $receivers;
        }

        JFactory::getMailer()->sendMail(
            $email, $sender, $receiver, $subject, $body, true, $cc, $bcc
        );
    }

    protected function tags_replace($text, $message) {
        $sender = JFactory::getUser($message->m_user_id_from);
        $replacements = array(
            '{{subject}}' => $message->m_subject,
            '{{message}}' => $message->m_message,
            '{{username}}' => $sender->username,
            '{{name}}' => $sender->name,
            '{{email}}' => $sender->email,
            '{{date}}' => $message->m_date_time,
        );
        foreach ($replacements as $tag => $value) {
            $text = str_replace($tag, $value, $text);
        }

        return $text;
    }
}
