<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetModelSearch extends JModelList
{
	protected 	$current;
	protected	$search;
	protected	$folders;
	protected	$files;
	protected	$messages;

	public function __construct($config = array()) {
		
		$this->current 	= JExtranetHelper::getSystem()->getDateToMySQL();
		$this->search  	= JFactory::getApplication()->getUserState('com_jextranet.search' );
		$this->folders 	= array();
		$this->files	= array();
		$this->messages	= array();
	
		parent::__construct($config);
	}

	
	public function getFolders() {
		
		if ( !isset($this->search) || !$this->search ) {
			return false;
		}
		
		$filter = $this->_db->Quote('%'.$this->_db->escape($this->search, true).'%', false);

		$query = $this->_db->getQuery(true);
		$query->select('a.fd_id, a.fd_name');
		$query->from('#__extranet_folders AS a');
		$query->where('( LOWER(a.fd_name) = LOWER(' . $this->_db->quote($this->_db->escape( $this->search )) . ') OR LOWER(a.fd_name) LIKE LOWER(' . $filter .'))' );
		$query->where('a.published = 1');

		$this->_db->setQuery ( $query );
		$this->folders = $this->_db->loadObjectList();

		return $this->folders;
	}


	public function getFiles() {
		
		if ( !isset($this->search) || !$this->search ) {
			return false;
		}

        $filter = $this->_db->quote('%'.
                    $this->_db->escape($this->search, true).'%', false);

		$query = $this->_db->getQuery(true);
		$query->select('a.f_id, a.f_title, a.f_parent');
		$query->from('#__extranet_files AS a');
        $query->where(
            '(LOWER(a.f_title) = LOWER('.
                $this->_db->quote($this->_db->escape($this->search)) .') '.
                'OR LOWER(a.f_title) LIKE LOWER(' . $filter .') '.
                'OR LOWER(a.f_description) LIKE '.$filter.')');
        $query->where(
            '((a.f_publish_up = "0000-00-00 00:00:00") 
                OR (a.f_publish_up <= ' . $this->_db->quote($this->current).'))'
        );
        $query->where(
            '((a.f_publish_down = "0000-00-00 00:00:00") OR (a.f_publish_down > '.
                $this->_db->Quote($this->current) . '))'
        );
		$query->where('a.published = 1');
		$this->_db->setQuery($query);
		$this->files = $this->_db->loadObjectList();
		return $this->files;
	}


	public function getMessages() {

		if ( !isset($this->search) || !$this->search ) {
			return false;
		}

		$filter = $this->_db->Quote('%'.$this->_db->escape($this->search, true).'%', false);

		$query = $this->_db->getQuery(true);
		$query->select('a.m_id, a.m_subject');
		$query->from('#__extranet_messages AS a');
		$query->where('( LOWER(a.m_subject) = ' . $this->_db->quote($this->_db->escape($this->search)) . 'OR LOWER(a.m_subject) LIKE LOWER('. $filter .') OR LOWER(a.m_message) = ' . 
					$this->_db->quote($this->_db->escape($this->search)) . ' OR LOWER(a.m_message) LIKE LOWER('. $filter .'))');
		$query->where ('( a.m_user_id_from = '. JFactory::getUser()->get('id') .' OR a.m_user_id_to = '. JFactory::getUser()->get('id') .' OR a.m_user_id_to REGEXP \'\"'. JFactory::getUser()->get('id') .'\"\' )');

		$this->_db->setQuery ( $query );
		$this->messages = $this->_db->loadObjectList();

		return $this->messages;
	}

}
?>
