<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');
?>

<?php if ( !$this->user->canView($this->level) && $this->folder->get('id') ) { return ; } ?>

<div class="pure-g">
    <ul class="pure-u-1 breadcrumb">
        <?php foreach ($this->route as $route) { ?>
            <li><a href="<?php echo JRoute::_('index.php?option=com_jextranet&view=folders&fid=' . $route->id, false) ; ?>"><?php echo $this->escape($route->name);?></a><span class="divider">/</span></li> 
        <?php } ?>
    </ul>
</div>
           
<?php if ( $description = $this->folder->get('description') ) {?>
<div class="pure-g">
    <div class="pure-u-1">
		<div class="panel">
			<div class="pure-g ptitle">
				<i class="ico-info"></i>
			</div>
			<div class="pcontent">
				<?php echo nl2br($description); ?>
			</div>
		</div>
    </div>
</div>
<?php } ?>			

<div class="clearfix"></div>
			
<?php if ( $this->folder->parent !== 0 ) { ?>
<div class="pure-g">
	<div class="pure-u-1 pure-u-md-11-24">
		<div class="pure-g">
			<div class="pure-u-1">
				<?php if ( $this->user->canDownload($this->level) ) { ?>
				<button type="button" class="button-small pure-button" onclick="JExtranetSubmitTaskID('file.download_all');"><i class="ico ico-cloud-download"></i> <?php echo JText::_('COM_JEXTRANET_DOWNLOAD_SELECTED');?></button>
				<button type="button" class="button-small pure-button" onclick="JExtranetToggleAllFiles();JExtranetSubmitTaskID('file.download_all');JExtranetToggleAllFiles();"><i class="ico ico-cloud-download"></i> <?php echo JText::_('COM_JEXTRANET_DOWNLOAD_ALL');?></button>
				<?php } ?>
			</div>
		</div>
	</div>

	<div class="pure-u-1 pure-u-md-1-24"><p></p></div>
      
	<div class="pure-u-1 pure-u-md-11-24">
		<div class="pure-g">
			<div class="pure-u-1">
	        <?php if ( $this->folder->get('id') && $this->user->canUpload($this->level) ) { ?>
		       	<button class="button-small pure-button" onclick="toggleUploader();return false;">
		            <i class="ico-cloud-upload"></i> <?php echo JText::_('COM_JEXTRANET_FOLDERS_ADD_FILES'); ?>
		        </button>
	        <?php } if ( $this->user->canCreateFolder($this->level) ) { ?>
		        <button class="button-small pure-button" onclick="JExtranetUploadWin('<?php echo JRoute::_('index.php?option=com_jextranet&view=createf&folder='. $this->folder->get('id') . '&tmpl=component');?>', '<?php echo $this->window->width;?>','<?php echo $this->window->height;?>');return false;">
		            <i class="ico-plus"></i> <?php echo JText::_('COM_JEXTRANET_FOLDERS_CREATE_FOLDER'); ?>
		        </button>
	        <?php } ?>
		    </div>
	    </div>
    </div>
</div>
<?php } ?>

<!-- upload -->	
<?php if ( $this->folder->get('id') && $this->user->canUpload($this->level) ) { ?>
<div class="clearfix"></div>
<div class="pure-g">
	<div class="pure-u-1" id="uf1" style="display: none;">
		<input type="file" name="afile" id="afile" style="display:none;" multiple="multiple" />
		<div class="inner-upload center" id="uploadarea">
			<h6><i class="ionut ionut-cloud-upload"></i> <?php echo JText::_('COM_JEXTRANET_MULTI_UPLOAD_DROP_HERE');?></h6>
			<span><?php echo JText::_('COM_JEXTRANET_MULTI_UPLOAD_DRAG_FILE') . '. ' . JText::_('COM_JEXTRANET_FILE_UPLOAD_ALLOWED') . $this->allowed;?></span>
			<div class="progress" style="width:0%;"><div class="meter"></div></div>
			<div class="info"></div>
		</div>
	</div>
</div>
<?php } ?>
<!-- /upload -->

<div class="clearfix"></div>

<?php if ( $this->folder->parent !== 0 ) { ?>
<div class="pure-g line1">
	<div class="pure-u-1">
		<span class="pure-menu-heading">
			<a href="<?php echo JRoute::_('index.php?option=com_jextranet&view=folders&fid=' . $this->folder->parent, false );?>"><i class="ico-action-undo"></i> <?php echo JText::_('COM_JEXTRANET_GO_BACK') ;?></a>
		</span>
	</div>
</div>
<?php } ?>

<?php $show_counter = $this->params->get('displayCount',0);?>
<?php $k=0; if (!empty($this->folders)) {
        foreach ($this->folders as $i => $folder) {
            $url = JRoute::_('index.php?option=com_jextranet&view=folders&fid=' . $folder->id ); ?>
<div class="pure-g pcontent <?php echo 'line' . $k%2;?>">
	<div class="pure-u-1">
    	<div class="pure-g">
			<div class="pure-u-4-24">
    			<span class="pure-menu-heading"><i class="ico-folder-alt jicon"></i></span> 
    		</div>
		    <div class="pure-u-14-24">
		    	<a class="pure-menu-heading" href="<?php echo $url;?>"><?php echo $this->escape($folder->title); ?> </a>
		    </div>
		    <div class="pure-u-4-24">
                <?php if ($show_counter) {?>
                <a class="pure-menu-heading" href="<?php echo $url;?>">
                    <?php echo sprintf(JText::_('COM_JEXTRANET_FOLDERS_COUNT_FILES'),
                            JExtranetHelperFolder::getInstance($folder->id)
                                ->files_count($show_counter)) ;?>
                </a>
                <?php } ?>
		    </div>
		</div>
	</div>
</div>
<?php $k++; } } ?>


<?php if (!empty($this->files)) {
    foreach ($this->files as $i => $file) { ?>
	<?php if (!in_array($file->title, $this->ignored)) { ?>
     <div class="pure-g pcontent <?php echo 'line' . $k%2;?>">
        <div class="pure-u-1">
        	<div class="pure-g">
				<div class="pure-u-4-24">
        			<div class="pure-menu-item pure-menu-has-children pure-menu-allow-hover">
						<a class="pure-menu-link" href="javascript:void(0);"><i class="ico-doc jicon"></i> <span class="filetype"><?php echo strtoupper($file->type);?></span> </a>
						<ul class="pure-menu-children">
							<?php if ($file->description) {?><small><?php echo $this->escape($file->description);?></small><?php } ?>
							<?php if ( $this->user->canDownload($this->level) ) { ?>
							<li class="pure-menu-item">
								<?php if ( $this->params->get('useTerms', 0) ) {?>
									<a href="javascript:JExtranetDownloadThisAfterTerms('<?php echo $file->id;?>','<?php echo JUri::root(false) ;?>');"> <?php echo JText::_('COM_JEXTRANET_FOLDERS_DOWNLOAD'); ?></a>
								<?php } else { ?> 
									<a href="javascript:JExtranetDownloadThis('<?php echo $file->id;?>');"> <?php echo JText::_('COM_JEXTRANET_FOLDERS_DOWNLOAD'); ?></a>
								<?php } ?>
							</li>

							<?php if ($file->type && in_array(strtolower($file->type), $this->previewtypes)) { ?>
							<li><a href="javascript:JExtranetPreview('file.preview', '<?php echo $file->id;?>');"><?php echo JText::_('COM_JEXTRANET_PREVIEW'); ?></a></li>
							<?php } ?>

							<?php if ( $this->params->get('useBookmarks',1) == 1 ) {?>
							<li class="pure-menu-item"><a href="javascript:JExtranetSubmitTaskID('file.bookmark', '<?php echo $file->id;?>');"> <?php echo JText::_('COM_JEXTRANET_FOLDERS_CLICK_TO_BOOKMARK');?></a></li>
							<?php } } ?>

							<?php if ( $this->user->canDelete($this->level) ) {?>
							<li class="pure-menu-item">
								<a href="<?php echo JRoute::_('index.php?option=com_jextranet&task=file.delete&id=' . $file->id . '&return=' . $this->return . '&t=' . time(), false); ?>"> <?php echo JText::_('COM_JEXTRANET_FOLDERS_DELETE_FILE');?></a>
							</li>
							<?php } ?>
						</ul>
					</div>
				</div>

	            <div class="pure-u-1 pure-u-md-12-24 pure-menu-heading title">
					<?php if ( $this->user->canDownload($this->level) ) { ?>
						<?php if ( $this->params->get('useTerms', 0)  ) { ?>
							<a href="javascript:JExtranetDownloadThisAfterTerms('<?php echo $file->id;?>','<?php echo JUri::root(false) ;?>');"><?php echo $this->escape( $file->title ); ?></a>
						<?php } else { ?> 
							<a href="javascript:JExtranetDownloadThis('<?php echo $file->id;?>');"><?php echo $this->escape( $file->title ); ?></a>
						<?php } ?>
					<?php } else { ?>
						<i class="right ico-ban"></i> <?php echo $this->escape( $file->title ); ?>
					<?php } ?>
	            </div>

	            <div class="pure-u-10-24 pure-u-md-4-24">
	            	<span class="pure-menu-heading"><?php echo JExtranetHelper::getSystem()->parseSize($file->size); ?></span>
	            </div>
           		
	            <div class="pure-u-12-24 pure-u-md-1-24">
					<span class="pure-menu-heading"><input type="checkbox" name="zip[]" value="<?php echo $file->id;?>" class="zips right " /></span>
	            </div>
	            
	            <?php if ($this->params->get('showFileDate',0) == 1) {?>
					<div class="pure-u-1 pure-u-md-4-24 pure-menu-heading small">
						<i class="ico-calendar"></i> <?php echo JFactory::getDate($file->creation)->format('Y-m-d') ;?>
					</div>
				<?php } ?>
            </div>
        </div>
    </div>
<?php  $k++; } } } ?>

<div class="paginatie">
    <?php echo $this->pagination->getPagesLinks();?>
</div>
