<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Copyright (C) 2011 Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetViewFolders extends JViewLegacy
{

	protected $folder;
	protected $files;
	protected $folders;
	protected $user;
	protected $pagination;
	protected $template;
	protected $params;
	protected $state;
	protected $route;
	protected $window;
	protected $level;
	protected $return;
	protected $allowed;
	protected $previewtypes;
	protected $ignored;
    protected $location_of_js;

	function display($tpl = null) {

		$this->user			= $this->get('User');

		JPluginHelper::importPlugin('jextranet');
		$dispatcher = JEventDispatcher::getInstance();
		$dispatcher->trigger('onAccessFolders', array($this->user));

		$this->folder		= $this->get('Folder');
		$this->files		= $this->get('Files');
		$this->folders		= $this->get('Folders');
		$this->pagination	= $this->get('Pagination');
		$this->template 	= $this->get('Template');
		$this->route		= $this->get('Route');
		$this->params		= $this->get('Params');
		$this->state		= $this->get('State');
		$this->window 		= new stdClass();
		$this->window->width 	= $this->params->get('lightBoxWidth', 500);
		$this->window->height 	=  $this->params->get('lightBoxHeight', 250);
		$this->level			=  $this->folder->get('id')  ?  $this->user->getAuthorisationLevel ($this->folder->get('id')) : array(2);
		$this->return 		= base64_encode ( JRoute::_('index.php?option=com_jextranet&view=folders&fid=' . $this->folder->get('id') ) );
		$this->allowed		= str_replace( ',', ', ', $this->params->get('allowedExtensions','doc,docx,xls,xlsx,ppt,pps,pptx,ppsx,odt,odf,odp,jpg,jpeg,pdf,txt,png,zip') );
		$previewtypes 		= $this->params->get('previewFiletypes');
		$ignored			= $this->params->get('ignoredFiletypes');
		$this->previewtypes = (stripos($previewtypes, ',') === false) ? array($previewtypes) : explode(',', $previewtypes);
		$this->ignored 		= (stripos($ignored, ',') === false) ? array($ignored) : explode(',', $ignored);
        $this->location_of_js = $this->params->get('location_of_js',
            'components/com_jextranet/assets/js/');
		
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		$tpl = JComponentHelper::getParams('com_jextranet')->get('template') == 1 ? 'legacy' : 'default';
		parent::display($tpl);
	}
}

